﻿@page "/"
@using WebApiSkeleton.Tasks.Queue.Client
@using WebApiSkeleton.Tasks.Models
@using Microsoft.AspNetCore.SignalR.Client
@using Newtonsoft.Json
@using WebApiSkeleton.Tasks.Example.BlazorClient.Notifications
@using WebApiSkeleton.Tasks.Example.TasksLibrary
@inject IClientBackgroundTaskQueue ClientQueue;
@inject NavigationManager Navigation;
@implements IAsyncDisposable
@rendermode InteractiveServer

<PageTitle>Home</PageTitle>

<button class="btn btn-primary" @onclick="SendTask">Send task</button>
<button class="btn btn-primary" @onclick="SendPeriodicTask">Send periodic task</button>
<table>
    <tr>
        <th>Task ID</th>
        <th>Current state</th>
        <th>Percent complete</th>
        <th>Comment</th>
        <th></th>
    </tr>
    @foreach (var task in _tasks)
    {
        <tr>
            <td>@task.TaskId</td>
            <td>@((TaskStates)task.StateId)</td>
            <td>@task.PercentComplete</td>
            <td>@task.Comment</td>
            <td>
                <button @onclick="() => CancelTask(task.TaskId)">cancel task</button>
            </td>
        </tr>
    }
</table>


@code {
    private List<TaskState> _tasks = new();
    private int Count { get; set; }
    private HubConnection? _hubConnection;

    protected override async Task OnInitializedAsync()
    {
        _hubConnection = new HubConnectionBuilder()
            .WithUrl(Navigation.ToAbsoluteUri("/task-hub"))
            .Build();

        _hubConnection.On("TaskUpdated", (object notification) =>
        {
            var task = JsonConvert.DeserializeObject<TaskUpdatedNotification>(notification.ToString()!);
            var existingTask = _tasks.Find(x => x.TaskId == task!.NewState.TaskId);
            if (existingTask is null)
            {
                _tasks.Add(task!.NewState);
            }
            else
            {
                existingTask.Comment = task!.NewState.Comment;
                existingTask.PercentComplete = task.NewState.PercentComplete;
                existingTask.StateId = task.NewState.StateId;
            }

            InvokeAsync(StateHasChanged);
        });

        await _hubConnection.StartAsync();
    }

    private async Task SendTask()
    {
        var task = new TestTask();
        await ClientQueue.EnqueueTask(task);
    }

    private async Task SendPeriodicTask()
    {
        var task = new TestPeriodicTask();
        await ClientQueue.EnqueueTask(task);
    }

    private async Task CancelTask(Guid taskId)
    {
        await ClientQueue.CancelTask(taskId);
    }

    public async ValueTask DisposeAsync()
    {
        if (_hubConnection is not null)
        {
            await _hubConnection.DisposeAsync();
        }
    }

}